Index: funcs/func_math.c
===================================================================
--- funcs/func_math.c	(revision 47782)
+++ funcs/func_math.c	(working copy)
@@ -31,6 +31,7 @@
 #include <stdlib.h>
 #include <stdio.h>
 #include <string.h>
+#include <math.h>
 #include <sys/types.h>
 
 #include "asterisk/module.h"
@@ -47,6 +48,9 @@
 	MULTIPLYFUNCTION,
 	SUBTRACTFUNCTION,
 	MODULUSFUNCTION,
+	POWFUNCTION,
+	SHLEFTFUNCTION,
+	SHRIGHTFUNCTION,
 	GTFUNCTION,
 	LTFUNCTION,
 	GTEFUNCTION,
@@ -105,12 +109,24 @@
 	} else if ((op = strchr(mvalue1, '%'))) {
 		iaction = MODULUSFUNCTION;
 		*op = '\0';
+	} else if ((op = strchr(mvalue1, 'P'))) {
+		iaction = POWFUNCTION;
+		*op = '\0';
+	} else if ((op = strchr(mvalue1, 'L'))) {
+		iaction = SHLEFTFUNCTION;
+		*op = '\0';
+	} else if ((op = strchr(mvalue1, 'R'))) {
+		iaction = SHRIGHTFUNCTION;
+		*op = '\0';
 	} else if ((op = strchr(mvalue1, '>'))) {
 		iaction = GTFUNCTION;
 		*op = '\0';
 		if (*(op + 1) == '=') {
 			*++op = '\0';
 			iaction = GTEFUNCTION;
+		} else if (*(op + 1) == '>') {
+			*++op = '\0';
+			iaction = SHRIGHTFUNCTION;
 		}
 	} else if ((op = strchr(mvalue1, '<'))) {
 		iaction = LTFUNCTION;
@@ -118,6 +134,9 @@
 		if (*(op + 1) == '=') {
 			*++op = '\0';
 			iaction = LTEFUNCTION;
+		} else if (*(op + 1) == '<') {
+			*++op = '\0';
+			iaction = SHLEFTFUNCTION;
 		}
 	} else if ((op = strchr(mvalue1, '='))) {
 		iaction = GTFUNCTION;
@@ -195,6 +214,25 @@
 
 			break;
 		}
+	case POWFUNCTION:
+		ftmp = pow(fnum1, fnum2);
+		break;
+	case SHLEFTFUNCTION:
+		{
+			int inum1 = fnum1;
+			int inum2 = fnum2;
+
+			ftmp = (inum1 << inum2);
+			break;
+		}
+	case SHRIGHTFUNCTION:
+		{
+			int inum1 = fnum1;
+			int inum2 = fnum2;
+
+			ftmp = (inum1 >> inum2);
+			break;
+		}
 	case GTFUNCTION:
 		ast_copy_string(buf, (fnum1 > fnum2) ? "TRUE" : "FALSE", len);
 		break;
